//BugZapper.cs

//audio
//datablock AudioProfile(bugZapperFireSound)
//{
//   filename    = "./bugZapperFire.wav";
//   description = AudioClosest3d;
//   preload = true;
//};

//datablock AudioProfile(bugZapperExplodeSound)
//{
//   filename    = "./Heavy_RL_blast.wav";
//   description = AudioDefault3d;
//   preload = true;
//};
//datablock AudioProfile(bugZapperLoopSound)
//{
//  filename    = "./bugZapperLoop.wav";
//   description = AudioCloseLooping3d;
//   preload = true;
//};

//muzzle flash effects

datablock ParticleData(zapperStarFireParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	windCoefficient      = 0;		    
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
    lifetimeMS           = 25;
    lifetimeVarianceMS   = 20;
    textureName          = "base/data/particles/star1";
	spinSpeed     = 10;
    spinRandomMin = -60;
	spinRandomMax = 70;
	
	colors[0]     = "0.9 0.9 0.1 0.6";
	colors[1]     = "1 1 0.5 0.0";

	sizes[0]      = 0.5;
    sizes[1]      = 0.2;

    times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;                                                                                       
};

datablock ParticleEmitterData(zapperFireEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin = 0;
   thetaMax = 0;
   phiReferenceVel = 0;
   phiVariance     = 0;
   overrideAdvance = false;
   particles = "zapperStarFireParticle";

   //   uiName = "Bug Zap";
};

//Trail
datablock ParticleData(bugZapParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/star1";
   spinSpeed     = 10;
   spinRandomMin = -60;
   spinRandomMax = 70;
   colors[0]     = "1 1 0.2 0.9";
   colors[1]     = "1 1 0.1 0.5";
   colors[2]     = "1 1 1 0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.2;
   sizes[2]      = 0.2;

   times[0] = 0;
   times[1] = 0.5;
   times[2] = 1;

   useInvAlpha = false;
};
datablock ParticleEmitterData(bugZapEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin = 0;
   thetaMax = 0;
   phiReferenceVel = 0;
   phiVariance     = 0;
   overrideAdvance = false;
   particles = "bugZapParticle";
   uiName = "Bug Zap";
};
datablock ParticleData(bugZapperExplosionParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 20;
	textureName          = "add-ons/projectile_radio_wave/bolt";
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]     = "1 1 0 1";
	colors[1]     = "1 1 0 0.3";

	sizes[0]      = 0.2;
	sizes[1]      = 0.2;
	
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(bugZapperExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "bugZapperExplosionParticle";

   uiName = "Bug Zapper Explosion";
//   emitterNode = TenthEmitterNode;
};

/////////////////
//--Explosion--//
/////////////////
datablock ExplosionData(bugZapperExplosion)
{
   //explosionShape = "";
   explosionShape = "";
	soundProfile = radioWaveExplosionSound;

	lifeTimeMS = 70;

   emitter[0] = bugZapperExplosionEmitter;
//   emitter[1] = bugZapperExplosionFlareEmitter;

//   debris = bugZapperFlareDebris;
//   debrisNum = 50;
//   debrisNumVariance = 10;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 180;
//   debrisVelocity = 120;
//   debrisVelocityVariance = 30;
   
   faceViewer = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 2.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.2;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0.6 0 0";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};


AddDamageType("bugZapperDirect",   '<bitmap:add-ons/Weapon_BugZapper/CI_zap> %1',    '%2 <bitmap:add-ons/Weapon_BugZapper/CI_zap> %1',1,1);
//AddDamageType("bugZapperRadius",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',1,0);
datablock ProjectileData(bugZapperProjectile)
{
   projectileShapeName	= "base/data/shapes/empty.dts";
   directDamage			= 5;
   vsMechDamage			= 1;
   vsSmallEnemyDamage	= 15;
   vsLargeEnemyDamage	= 2;
   directDamageType = $DamageType::bugZapperDirect;
   radiusDamageType = $DamageType::bugZapperDirect;
   impactImpulse	   = 30;
   verticalImpulse	   = 5;
   explosion           = bugZapperExplosion;
   particleEmitter     = bugZapEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 4;             
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

//   sound = bugZapperLoopSound;

   muzzleVelocity      = 200;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 100;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 1;
   lightColor  = "1 1 0.0";

   uiName = "Bug Zapper Zap";
};

//////////
// item //
//////////
datablock ItemData(bugZapperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./bugZapper2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Bug Zapper";
	iconName = "./Icon_bugZapper";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = bugZapperImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(bugZapperImage)
{
   // Basic Item properties
   shapeFile = "./bugZapper2.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = bugZapperProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
//   minShotTime = 10;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

		stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "fire1";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= zapperFireEmitter;
	stateEmitterTime[2]				= 0.11;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= radioWaveExplosionSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.01;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";
};

function bugZapperImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
//	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
//	%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%spread = 0.0015;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function bugZapperProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{

	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
		%damageType = %this.DirectDamageType;

	%scale = getWord(%obj.getScale(), 2);
	%directDamage = %this.directDamage * %scale;
	%vsMechDamage = %this.vsMechDamage * %scale;
	%vsSmallEnemyDamage = %this.vsSmallEnemyDamage * %scale;
	%vsLargeEnemyDamage = %this.vsLargeEnemyDamage * %scale;

	if(%col.isMech == 1 || %col.getDatablock().isMech == 1) {
		%col.damage(%obj, %pos, %vsMechDamage, %damageType); //applies very weak damage
	}
	else if(%col.isLargeEnemy == 1 || %col.getDatablock().isLargeEnemy == 1) {
		%col.damage(%obj, %pos, %vsLargeEnemyDamage, %damageType); //applies weak damage
	}
	else if(%col.isSmallEnemy == 1 || %col.getDatablock().isSmallEnemy == 1) {
		%col.damage(%obj, %pos, %vsSmallEnemyDamage, %damageType); //applies heavy damage
	}
	else {
		%col.damage(%obj, %pos, %directDamage, %damageType); //applies normal damage
	}
}
